#include <iostream>
#include <vector>
#include "histogram.h"
#include "text.h"
#include "histogram_internal.h"
#include "svg.h"
#include <curl/curl.h>

using namespace std;
const size_t SCREEN_WIDTH = 80;
const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;

struct Input
{
    vector<double> numbers;
    size_t bin_count{};
};

Input input_data(istream& stream, bool prompt)
{
    size_t number_count;
    if (prompt){
        cerr << "Enter number count:";
    }
    stream >> number_count;

    Input in;

    in.numbers.resize(number_count);
    if (prompt){
        cerr << "Enter numbers: ";
    }
    for(size_t i = 0; i < number_count; i++)
        stream >> in.numbers[i];

    cerr << "Enter number of bins: ";
    stream >> in.bin_count;

    return in;

}

int main(int argc, char* argv[])
{
    if (argc > 1){
        auto i = 0;
        while (i < argc){
                cerr << "arg[" << i << "] = " << argv[i] << endl;
                i++;
            }
        return 0;
    }

    curl_global_init(CURL_GLOBAL_ALL);
    bool prompt = true;
    auto in = input_data(cin, prompt);

    auto bins = make_histogram(in.numbers, in.bin_count);
  // show_histogram_svg_vertical(bins);
    show_histogram_svg(bins);

}
